# RevokeSecurityGroupRules

## 1. API Description

This API (RevokeSecurityGroupRules) is used to remove security group rules.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Status of security group should be</mark> <mark style="color:blue;">`Available`</mark><mark style="color:blue;">.</mark>
* <mark style="color:blue;">You can use</mark> [<mark style="color:purple;">`DescribeSecurityGroups`</mark>](/api-reference/compute/vm/security-group/describesecuritygroups.md) <mark style="color:blue;">to query the ID of the security group.</mark>
* <mark style="color:blue;">Editing is not supported for default security group.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                                     | Description           |
| --------------- | -------- | ------------------------------------------------------------------------ | --------------------- |
| securityGroupId | Yes      | String                                                                   | Security group ID.    |
| ruleInfos       | Yes      | Array of [RuleInfo](/api-reference/compute/vm/datastructure.md#ruleinfo) | Security group rules. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Remove security group rules.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: RevokeSecurityGroupRules
<Common Request Params>

Request:
{
  "securityGroupId": "your-security-group-id",
  "ruleInfos": [
    {
      "direction": "egress",
      "policy": "accept",
      "priority": 6,
      "ipProtocol": "tcp",
      "portRange": "22/22",
      "cidrIp": "0.0.0.0/0"
    }
  ]
}

Response:
{
  "requestId": "TB63CDCBC-6788-4E65-A1FA-E52B8C6FE349",
  "response": {
    "requestId": "TB63CDCBC-6788-4E65-A1FA-E52B8C6FE349"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                                 | Description                                                  |
| ---------------- | ---------------------------------------------------------- | ------------------------------------------------------------ |
| 404              | INVALID\_SECURITY\_GROUP\_NOT\_FOUND                       | Security group does not exist.                               |
| 403              | OPERATION\_DENIED\_SECURITY\_GROUP\_STATUS\_NOT\_AVAILABLE | Status of security group should be `Available`.              |
| 404              | INVALID\_SECURITY\_GROUP\_RULE\_NOT\_FOUND                 | Security group rule does not exist.                          |
| 403              | OPERATION\_DENIED\_DEFAULT\_SECURITY\_GROUP\_NOT\_SUPPORT  | Operations on the default security groups are not supported. |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/vm/security-group/revokesecuritygrouprules.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
